/*
 * task.c
 *
 *  Created on: December 23, 2019
 *      Author: lidq
 */

#include <adc_task.h>

#define ADC_TIMEOUT (1000)
#define ADC_FILTER (0.3f)

uint16_t ctl_pwm[ADC_CHS] = { 0 };
uint8_t ctl_pwm_reverse[ADC_CHS] = { 0, 0, 0, 1 };

float adc_value[ADC_CHS] = { 0 };
static float adc_value_pre[ADC_CHS] = { 0 };

extern ADC_HandleTypeDef hadc1;

void* adc_pthread(void* arg)
{
	uint16_t value[ADC_CHS] = { 0 };

	HAL_ADCEx_Calibration_Start(&hadc1);

	uint32_t tk = 0;
	char buff[100] = { 0 };

	while (1)
	{
		for (int i = 0; i < ADC_CHS; i++)
		{
			HAL_ADC_Start(&hadc1);
			HAL_ADC_PollForConversion(&hadc1, ADC_TIMEOUT);
			value[i] = HAL_ADC_GetValue(&hadc1);
			float v = (float)value[i] / 4096.0f;

			if (ctl_pwm_reverse[i])
			{
				v = 1.0f - v;
			}

			adc_value[i] = v * ADC_FILTER + adc_value_pre[i] * (1.0f - ADC_FILTER);
			adc_value_pre[i] = adc_value[i];

			ctl_pwm[i] = adc_value[i] * (CTL_PWM_MAX - CTL_PWM_MIN) + CTL_PWM_MIN;
		}
		HAL_ADC_Stop(&hadc1);

		tk++;
		sleep_ticks(2);
	}
	return NULL;
}

void adc_task(void)
{
	pcb_create(PCB_ADC_PRIO, &adc_pthread, NULL, PCB_ADC_SIZE);
}
